# std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r > Class Template Reference
[Random Number Generators]

List of all members.

## Detailed Description

### template<class _UniformRandomNumberGenerator, int __p, int __r>
class std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >

Produces random numbers from some base engine by discarding blocks of data.

0 <= `__r` <= `__p`

Definition at line 1033 of file random.

## Public Types

- typedef _UniformRandomNumberGenerator base_type
- typedef base_type::result_type result_type

## Public Member Functions

- const base_type & base () const
- template<class _Gen> discard_block (_Gen &__g)
- discard_block (unsigned long __s)
- discard_block (const base_type &__rng)
- discard_block ()
- result_type max () const
- result_type min () const
- result_type operator() ()
- template<class _Gen> void seed (_Gen &__g)
- void seed ()

## Static Public Attributes

- static const int block_size
- static const int used_block

## Friends

- bool operator!= (const discard_block &__lhs, const discard_block &__rhs)
- template<class _UniformRandomNumberGenerator1, int __p1, int __r1, typename _CharT, typename _Traits> std::basic_ostream< _CharT,
  _Traits > & operator<< (std::basic_ostream< _CharT, _Traits > &__os, const discard_block< _UniformRandomNumberGenerator1, __p1, __r1 > &__x)
- bool operator== (const discard_block &__lhs, const discard_block &__rhs)
- template<class _UniformRandomNumberGenerator1, int __p1, int __r1, typename _CharT, typename _Traits> std::basic_istream< _CharT,
  _Traits > & operator>> (std::basic_istream< _CharT, _Traits > &__is, discard_block< _UniformRandomNumberGenerator1, __p1, __r1 > &__x)

## Member Typedef Documentation

template<class _UniformRandomNumberGenerator, int __p, int __r>

typedef _UniformRandomNumberGenerator std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::base_type

The type of the underlying generator engine.

Definition at line 1040 of file random.

template<class _UniformRandomNumberGenerator, int __p, int __r>

typedef base_type::result_type std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::result_type

The type of the generated random value.

Definition at line 1042 of file random.

## Constructor & Destructor Documentation

template<class _UniformRandomNumberGenerator, int __p, int __r>

std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::discard_block | ( |  | ) | `[inline]`

Constructs a default discard_block engine.

The underlying engine is default constructed as well.

Definition at line 1053 of file random.

template<class _UniformRandomNumberGenerator, int __p, int __r>

std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::discard_block | ( | const base_type & | __rng | ) | `[inline, explicit]`

Copy constructs a discard_block engine.

Copies an existing base class random number geenerator.

Parameters:

  | rng | An existing (base class) engine object.

Definition at line 1063 of file random.

template<class _UniformRandomNumberGenerator, int __p, int __r>

std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::discard_block | ( | unsigned long | __s | ) | `[inline, explicit]`

Seed constructs a discard_block engine.

Constructs the underlying generator engine seeded with `__s`.

Parameters:

  | __s | A seed value for the base class engine.

Definition at line 1073 of file random.

template<class _UniformRandomNumberGenerator, int __p, int __r>
template<class _Gen>

std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::discard_block | ( | _Gen & | __g | ) | `[inline]`

Generator construct a discard_block engine.

Parameters:

  | __g | A seed generator function.

Definition at line 1082 of file random.

## Member Function Documentation

template<class _UniformRandomNumberGenerator, int __p, int __r>

const base_type& std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::base | ( |  | ) | const`[inline]`

Gets a const reference to the underlying generator engine object.

Definition at line 1111 of file random.

template<class _UniformRandomNumberGenerator, int __p, int __r>

result_type std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::max | ( |  | ) | const`[inline]`

Gets the maximum value in the generated random number range.

Definition at line 1125 of file random.

template<class _UniformRandomNumberGenerator, int __p, int __r>

result_type std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::min | ( |  | ) | const`[inline]`

Gets the minimum value in the generated random number range.

Definition at line 1118 of file random.

template<class _UniformRandomNumberGenerator, int __p, int __r>

discard_block< _UniformRandomNumberGenerator, __p, __r >::result_type std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::operator() | ( |  | ) |

Gets the next value in the generated random number sequence.

Definition at line 587 of file random.tcc.

References std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::block_size, and std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::used_block.

template<class _UniformRandomNumberGenerator, int __p, int __r>
template<class _Gen>

void std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::seed | ( | _Gen & | __g | ) | `[inline]`

Reseeds the discard_block object with the given seed generator function.

Parameters:

  | __g | A seed generator function.

Definition at line 1101 of file random.

template<class _UniformRandomNumberGenerator, int __p, int __r>

void std::tr1::discard_block< _UniformRandomNumberGenerator, __p, __r >::seed | ( |  | ) | `[inline]`

Reseeds the discard_block object with the default seed for the underlying base class generator engine.

Definition at line 1089 of file random.

## Friends And Related Function Documentation

template<class _UniformRandomNumberGenerator, int __p, int __r>

bool operator!= | ( | const discard_block< _UniformRandomNumberGenerator, __p, __r > & | __lhs,
|  | const discard_block< _UniformRandomNumberGenerator, __p, __r > & | __rhs |
| ) |  |  | `[friend]`

Compares two discard_block random number generator objects of the same type for inequality.

Parameters:

  | __lhs | A discard_block random number generator object.
  | __rhs | Another discard_block random number generator object.

Returns:
  true if the two objects are not equal, false otherwise.

Definition at line 1159 of file random.

template<class _UniformRandomNumberGenerator, int __p, int __r>
template<class _UniformRandomNumberGenerator1, int __p1, int __r1, typename _CharT, typename _Traits>

std::basic_ostream<_CharT, _Traits>& operator<< | ( | std::basic_ostream< _CharT, _Traits > & | __os,
|  | const discard_block< _UniformRandomNumberGenerator1, __p1, __r1 > & | __x |
| ) |  |  | `[friend]`

Inserts the current state of a discard_block random number generator engine `__x` into the output stream `__os`.

Parameters:

  | __os | An output stream.
  | __x | A discard_block random number generator engine.

Returns:
  The output stream with the state of `__x` inserted or in an error state.

template<class _UniformRandomNumberGenerator, int __p, int __r>

bool operator== | ( | const discard_block< _UniformRandomNumberGenerator, __p, __r > & | __lhs,
|  | const discard_block< _UniformRandomNumberGenerator, __p, __r > & | __rhs |
| ) |  |  | `[friend]`

Compares two discard_block random number generator objects of the same type for equality.

Parameters:

  | __lhs | A discard_block random number generator object.
  | __rhs | Another discard_block random number generator object.

Returns:
  true if the two objects are equal, false otherwise.

Definition at line 1145 of file random.

template<class _UniformRandomNumberGenerator, int __p, int __r>
template<class _UniformRandomNumberGenerator1, int __p1, int __r1, typename _CharT, typename _Traits>

std::basic_istream<_CharT, _Traits>& operator>> | ( | std::basic_istream< _CharT, _Traits > & | __is,
|  | discard_block< _UniformRandomNumberGenerator1, __p1, __r1 > & | __x |
| ) |  |  | `[friend]`

Extracts the current state of a % subtract_with_carry random number generator engine `__x` from the input stream `__is`.

Parameters:

  | __is | An input stream.
  | __x | A discard_block random number generator engine.

Returns:
  The input stream with the state of `__x` extracted or in an error state.

The documentation for this class was generated from the following files:

- random
- random.tcc